from collections import deque, defaultdict

def find_guarded_warehouses(n, m, k, roads, guards):
    # Построим граф
    graph = defaultdict(list)
    
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    
    guarded_warehouses = set()
    
    # BFS для каждого охранника
    for p, h in guards:
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        visited = set()
        visited.add(p)
        
        while queue:
            current, distance = queue.popleft()
            if distance < h:
                for neighbor in graph[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))
        
        guarded_warehouses.update(visited)
    
    # Подготовим результат
    guarded_warehouses = sorted(guarded_warehouses)
    print(len(guarded_warehouses))
    print(" ".join(map(str, guarded_warehouses)))

# Пример входных данных
n = 5
m = 4
k = 2
roads = [(1, 2), (2, 3), (3, 4), (4, 5)]
guards = [(1, 2), (5, 1)]

find_guarded_warehouses(n, m, k, roads, guards)